
int ArrayInitialize(PARRAY pArray, 
								LONG i32InitialSize,
								LONG i32BlockSize,
								LONG i32ElementSize)
{
	Memset(pArray, 0, sizeof(ARRAY));

	pArray->i32Capacity      = i32InitialSize;
	pArray->i32BlockSize     = i32BlockSize;
	pArray->i32NextFreeIndex = -1;
	pArray->i32ElementSize   = i32ElementSize;
	
	
	pArray->pvElementStorage  = (PVOID *) Malloc(sizeof(PVOID) *
									   i32InitialSize);
		
	if (pArray->pvElementStorage == NULL)
	{
		return (0);
	}
	
	Memset(pArray->pvElementStorage, 0, sizeof(PVOID) * i32InitialSize);
	return (1);
}


int ArrayDeInitialize(PARRAY pArray)
{

	PVOID *pvElementStorage = pArray->pvElementStorage;

	LONG i32Ctr = 0;
	LONG i32Capacity = pArray->i32Capacity;

	while (i32Ctr < i32Capacity)
	{
		PVOID pElement = *(pvElementStorage + i32Ctr);
		if (pElement != NULL)
		{
			Memset(pElement, 0, pArray->i32ElementSize);
			
			Free(pElement);
			
		}
		i32Ctr++;
	}

	Free(pvElementStorage);
	pArray->pvElementStorage = NULL;
	return (1);
}

